﻿Type=Class
Version=5.5
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'SpriteAnimator is a utility class that can move and animate sprites.

Sub Class_Globals
	'An array with the source rectangles. This is useful when working with sprite sheets.
	Private srcRects() As Rect
	'An array with the animation frames.
	Private bitmaps() As Bitmap
	Private index As Int
	Private interval As Int
	
	'Change frame each x ticks
	Public AnimationInterval As Int
	Public vx, vy As Int
	Public width, height As Int
End Sub

Public Sub Initialize
	AnimationInterval = 1
End Sub

Public Sub SetFrames(bd As BitmapData, vSrcRects() As Rect, vBitmaps() As Bitmap)
	srcRects = vSrcRects
	bitmaps = vBitmaps
	bd.SrcRect = srcRects(0) 'start with the first frame
	bd.Bitmap = bitmaps(0)
	index = 0
	interval = 0
End Sub

'returns True if the object moved out of the screen (to the bottom).
Public Sub Tick (bd As BitmapData) As Boolean
	'move the sprite based on vx and vy
	bd.DestRect.Left = bd.DestRect.Left + vx
	bd.DestRect.Top = bd.DestRect.Top + vy
	
	'in this game objects that go out of the screen return from the other side:
	If vx > 0 And bd.DestRect.CenterX > 100%x Then 
		bd.DestRect.Left = -width / 2
	Else If vx < 0 And bd.DestRect.CenterX < 0 Then
		bd.DestRect.Left = 100%x + width / 2
	End If
	
	If bd.DestRect.CenterY > 100%y Then
		Return False 'moved out of the screen
	End If
	'Don't forget to update the Right and Bottom properties
	bd.DestRect.Right = bd.DestRect.Left + width
	bd.DestRect.Bottom = bd.DestRect.Top + height
	
	interval = interval + 1
	If AnimationInterval = interval Then
		'change the animation frame.
		interval = 0
		index = (index + 1) Mod bitmaps.Length
		bd.SrcRect = srcRects(index)
		bd.Bitmap = bitmaps(index)
	End If
	Return True
End Sub

